// (C) 2001-2025 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.




`ifndef CAL_ARCH_FP_INTERFACE
   `include "cal_io96b_interface.svh"
`endif

module emif_io96b_hps_emif_io96b_hps_200_g4nkt2a_emif_0_ddr4comp_emif_io96b_cal_200_hpbproa #(
   parameter NUM_CALBUS_PERIPHS = 1,
   parameter NUM_CALBUS_PLLS    = 1,
   parameter PORT_M_AXIL_ENABLE = 0,
   parameter DEBUG_TOOLS_EN = 0,
   parameter PORT_S_AXIL_MODE = "DISABLE",
   localparam PARAM_TABLE_WIDTH = 16384,
   localparam PORT_AXIL_ADDRESS_WIDTH = 27,
   localparam PORT_AXIL_DATA_WIDTH = 32
   
   ) ( 
   output [1341:0]  periph_calbus_0,
   input  [1314:0]  periph_calbus_readdata_0,
   input  [2*PARAM_TABLE_WIDTH-1:0] periph_calbus_param_table_0,

   output [1341:0]  periph_calbus_1,
   input  [1314:0]  periph_calbus_readdata_1,
   input  [2*PARAM_TABLE_WIDTH-1:0] periph_calbus_param_table_1,

   output [ 57:0]   pll_calbus_0,
   input  [ 31:0]   pll_calbus_readdata_0,

   output [ 57:0]   pll_calbus_1,
   input  [ 31:0]   pll_calbus_readdata_1,

   output [ 57:0]   pll_calbus_2,
   input  [ 31:0]   pll_calbus_readdata_2,
   
   input  [7:0]     ls_to_cal,
   output [7:0]     ls_from_cal,
   input            fbr_c2f_rst_n,
//// User/Debug Interface via NoC
   input                                tniul_rst_n      ,

//// User/Debug Interface directy to Fabric
   input                                 s0_axi4lite_clk     ,
   input                                 s0_axi4lite_rst_n   ,
   input   [PORT_AXIL_ADDRESS_WIDTH-1:0] s0_axi4lite_awaddr  ,
   input                                 s0_axi4lite_awvalid ,
   output                                s0_axi4lite_awready ,
   input   [PORT_AXIL_ADDRESS_WIDTH-1:0] s0_axi4lite_araddr  ,
   input                                 s0_axi4lite_arvalid ,
   output                                s0_axi4lite_arready ,
   input   [PORT_AXIL_DATA_WIDTH-1:0]    s0_axi4lite_wdata   ,
   input                                 s0_axi4lite_wvalid  ,
   output                                s0_axi4lite_wready  ,
   output   [1:0]                        s0_axi4lite_rresp   ,
   output  [PORT_AXIL_DATA_WIDTH-1:0]    s0_axi4lite_rdata   ,
   output                                s0_axi4lite_rvalid  ,
   input                                 s0_axi4lite_rready  ,
   output   [1:0]                        s0_axi4lite_bresp   ,
   output                                s0_axi4lite_bvalid  ,
   input                                 s0_axi4lite_bready  ,
   
//// User Interface directy from Fabric (M)
//output                                m0_axi4lite_clk     ,
   output  [PORT_AXIL_ADDRESS_WIDTH-1:0] m0_axi4lite_awaddr  ,
   output                                m0_axi4lite_awvalid ,
   input                                 m0_axi4lite_awready ,
   output  [PORT_AXIL_ADDRESS_WIDTH-1:0] m0_axi4lite_araddr  ,
   output                                m0_axi4lite_arvalid ,
   input                                 m0_axi4lite_arready ,
   output   [PORT_AXIL_DATA_WIDTH-1:0]    m0_axi4lite_wdata   ,
   output                                m0_axi4lite_wvalid  ,
   input                                 m0_axi4lite_wready  ,
   input    [1:0]                        m0_axi4lite_rresp   ,
   input   [PORT_AXIL_DATA_WIDTH-1:0]    m0_axi4lite_rdata   ,
   input                                 m0_axi4lite_rvalid  ,
   output                                m0_axi4lite_rready  ,
   input    [1:0]                        m0_axi4lite_bresp   ,
   input                                 m0_axi4lite_bvalid  ,
   output                                m0_axi4lite_bready  ,
   output [2:0]                          m0_axi4lite_awprot  ,
   output [2:0]                          m0_axi4lite_arprot  ,
   output [(PORT_AXIL_DATA_WIDTH/8)-1:0] m0_axi4lite_wstrb   ,
   

   input  [2:0]                          s0_axi4lite_awprot  ,
   input  [2:0]                          s0_axi4lite_arprot  ,
   input  [(PORT_AXIL_DATA_WIDTH/8)-1:0] s0_axi4lite_wstrb,   

   output  wire          s0_noc_axi4lite_clk,         
   output  wire          s0_noc_axi4lite_rst_n,       
   input  wire [26:0]    s0_noc_axi4lite_awaddr,      
   input  wire           s0_noc_axi4lite_awvalid,     
   output wire           s0_noc_axi4lite_awready,     
   input  wire [26:0]    s0_noc_axi4lite_araddr,      
   input  wire           s0_noc_axi4lite_arvalid,     
   output wire           s0_noc_axi4lite_arready,     
   input  wire [31:0]    s0_noc_axi4lite_wdata,       
   input  wire           s0_noc_axi4lite_wvalid,      
   output wire           s0_noc_axi4lite_wready,      
   output wire [1:0]     s0_noc_axi4lite_rresp,       
   output wire [31:0]    s0_noc_axi4lite_rdata,       
   output wire           s0_noc_axi4lite_rvalid,      
   input  wire           s0_noc_axi4lite_rready,      
   output wire [1:0]     s0_noc_axi4lite_bresp,       
   output wire           s0_noc_axi4lite_bvalid,      
   input  wire           s0_noc_axi4lite_bready,      
   input  wire [2:0]     s0_noc_axi4lite_awprot,      
   input  wire [2:0]     s0_noc_axi4lite_arprot,      
   input  wire [3:0]     s0_noc_axi4lite_wstrb       


   );

   localparam AMM_TO_AXIL_INTERCONNECT_ONLY = DEBUG_TOOLS_EN && (PORT_S_AXIL_MODE != "FABRIC");
   localparam ADD_TNIU = (PORT_S_AXIL_MODE == "NOC");
   localparam EXPORT_NOC_INTF = (PORT_S_AXIL_MODE == "HARD_PATH");
   localparam EXPORT_FBR_INTF = (PORT_S_AXIL_MODE == "FABRIC");

   wire   [31:0] jamb_master_readdata;                                       
   wire          jamb_master_waitrequest;                                    
   wire   [31:0] jamb_master_address;                                        
   wire          jamb_master_read;                                           
   wire    [3:0] jamb_master_byteenable;                                     
   wire          jamb_master_readdatavalid;                                  
   wire          jamb_master_write;                                          
   wire   [31:0] jamb_master_writedata;                                      


   AXILITE_BUS #( 
      .PORT_AXI_AXADDR_WIDTH  (PORT_AXIL_ADDRESS_WIDTH),
      .PORT_AXI_DATA_WIDTH    (PORT_AXIL_DATA_WIDTH),
      .PORT_AXI_RESP_WIDTH    (2),
      .PORT_AXI_STRB_WIDTH    (4),
      .PORT_AXI_AXPROT_WIDTH  (3)
   ) s_noc_axil_to_arch (), 
     s_noc_axil_to_tniu (),
     s_fbr_axil_to_arch (),
     s_fbr_axil_to_jamb_and_arbit ();

   generate

      if (ADD_TNIU) begin: connect_arch_noc_axil_to_tniu

         assign s_noc_axil_to_tniu.arready  = s_noc_axil_to_arch.arready ;
         assign s_noc_axil_to_tniu.awready  = s_noc_axil_to_arch.awready ;
         assign s_noc_axil_to_tniu.bresp    = s_noc_axil_to_arch.bresp   ;
         assign s_noc_axil_to_tniu.bvalid   = s_noc_axil_to_arch.bvalid  ;
         assign s_noc_axil_to_tniu.rdata    = s_noc_axil_to_arch.rdata   ;
         assign s_noc_axil_to_tniu.rresp    = s_noc_axil_to_arch.rresp   ;
         assign s_noc_axil_to_tniu.rvalid   = s_noc_axil_to_arch.rvalid  ;
         assign s_noc_axil_to_tniu.wready   = s_noc_axil_to_arch.wready  ;

         assign s_noc_axil_to_tniu.clk      = s_noc_axil_to_arch.clk     ;
         assign s_noc_axil_to_tniu.rst_n    = s_noc_axil_to_arch.rst_n   ;

         assign s_noc_axil_to_arch.awaddr   = s_noc_axil_to_tniu.awaddr  ;
         assign s_noc_axil_to_arch.awprot   = s_noc_axil_to_tniu.awprot  ;
         assign s_noc_axil_to_arch.awvalid  = s_noc_axil_to_tniu.awvalid ;
         assign s_noc_axil_to_arch.wdata    = s_noc_axil_to_tniu.wdata   ;
         assign s_noc_axil_to_arch.wstrb    = s_noc_axil_to_tniu.wstrb   ;
         assign s_noc_axil_to_arch.wvalid   = s_noc_axil_to_tniu.wvalid  ;
         assign s_noc_axil_to_arch.bready   = s_noc_axil_to_tniu.bready  ;
         assign s_noc_axil_to_arch.araddr   = s_noc_axil_to_tniu.araddr  ;
         assign s_noc_axil_to_arch.arprot   = s_noc_axil_to_tniu.arprot  ;
         assign s_noc_axil_to_arch.arvalid  = s_noc_axil_to_tniu.arvalid ;
         assign s_noc_axil_to_arch.rready   = s_noc_axil_to_tniu.rready  ;

         assign s0_noc_axi4lite_arready  = '0;
         assign s0_noc_axi4lite_awready  = '0;
         assign s0_noc_axi4lite_bresp    = '0;
         assign s0_noc_axi4lite_bvalid   = '0;
         assign s0_noc_axi4lite_rdata    = '0;
         assign s0_noc_axi4lite_rresp    = '0;
         assign s0_noc_axi4lite_rvalid   = '0;
         assign s0_noc_axi4lite_wready   = '0;
         assign s0_noc_axi4lite_clk      = '0;
         assign s0_noc_axi4lite_rst_n    = '1;

      end else if (EXPORT_NOC_INTF) begin: export_arch_noc_axil

         assign s0_noc_axi4lite_arready  = s_noc_axil_to_arch.arready ;
         assign s0_noc_axi4lite_awready  = s_noc_axil_to_arch.awready ;
         assign s0_noc_axi4lite_bresp    = s_noc_axil_to_arch.bresp   ;
         assign s0_noc_axi4lite_bvalid   = s_noc_axil_to_arch.bvalid  ;
         assign s0_noc_axi4lite_rdata    = s_noc_axil_to_arch.rdata   ;
         assign s0_noc_axi4lite_rresp    = s_noc_axil_to_arch.rresp   ;
         assign s0_noc_axi4lite_rvalid   = s_noc_axil_to_arch.rvalid  ;
         assign s0_noc_axi4lite_wready   = s_noc_axil_to_arch.wready  ;
         assign s0_noc_axi4lite_clk      = s_noc_axil_to_arch.clk   ;
         assign s0_noc_axi4lite_rst_n    = s_noc_axil_to_arch.rst_n ;

         assign s_noc_axil_to_arch.awaddr   = s0_noc_axi4lite_awaddr  ;
         assign s_noc_axil_to_arch.awprot   = s0_noc_axi4lite_awprot  ;
         assign s_noc_axil_to_arch.awvalid  = s0_noc_axi4lite_awvalid ;
         assign s_noc_axil_to_arch.wdata    = s0_noc_axi4lite_wdata   ;
         assign s_noc_axil_to_arch.wstrb    = s0_noc_axi4lite_wstrb   ;
         assign s_noc_axil_to_arch.wvalid   = s0_noc_axi4lite_wvalid  ;
         assign s_noc_axil_to_arch.bready   = s0_noc_axi4lite_bready  ;
         assign s_noc_axil_to_arch.araddr   = s0_noc_axi4lite_araddr  ;
         assign s_noc_axil_to_arch.arprot   = s0_noc_axi4lite_arprot  ;
         assign s_noc_axil_to_arch.arvalid  = s0_noc_axi4lite_arvalid ;
         assign s_noc_axil_to_arch.rready   = s0_noc_axi4lite_rready  ;

      end else begin: tie_off_noc_axil
         assign s0_noc_axi4lite_arready  = '0;
         assign s0_noc_axi4lite_awready  = '0;
         assign s0_noc_axi4lite_bresp    = '0;
         assign s0_noc_axi4lite_bvalid   = '0;
         assign s0_noc_axi4lite_rdata    = '0;
         assign s0_noc_axi4lite_rresp    = '0;
         assign s0_noc_axi4lite_rvalid   = '0;
         assign s0_noc_axi4lite_wready   = '0;
         assign s0_noc_axi4lite_clk      = '0;
         assign s0_noc_axi4lite_rst_n    = '1;

         assign s_noc_axil_to_arch.awaddr   = '0;
         assign s_noc_axil_to_arch.awprot   = '0;
         assign s_noc_axil_to_arch.awvalid  = '0;
         assign s_noc_axil_to_arch.wdata    = '0;
         assign s_noc_axil_to_arch.wstrb    = '0;
         assign s_noc_axil_to_arch.wvalid   = '0;
         assign s_noc_axil_to_arch.bready   = '0;
         assign s_noc_axil_to_arch.araddr   = '0;
         assign s_noc_axil_to_arch.arprot   = '0;
         assign s_noc_axil_to_arch.arvalid  = '0;
         assign s_noc_axil_to_arch.rready   = '0;

      end

   endgenerate



   io0_emif_io96b_hps_emif_io96b_hps_200_g4nkt2a_emif_0_ddr4comp_emif_io96b_cal_200_hpbproa_cal_arch_fp_top #(
      .NUM_CALBUS_PERIPHS      (NUM_CALBUS_PERIPHS),
      .NUM_CALBUS_PLLS         (NUM_CALBUS_PLLS),
      .PORT_M_AXIL_ENABLE      (PORT_M_AXIL_ENABLE),
      .PORT_AXIL_ADDRESS_WIDTH (27)
   ) cal_arch_0 (

      .periph_calbus_0             (periph_calbus_0),                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         
      .periph_calbus_readdata_0    (periph_calbus_readdata_0),                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                
      .periph_calbus_param_table_0 (periph_calbus_param_table_0),                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             
      .periph_calbus_1             (periph_calbus_1),                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         
      .periph_calbus_readdata_1    (periph_calbus_readdata_1),                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                
      .periph_calbus_param_table_1 (periph_calbus_param_table_1),                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             
      .pll_calbus_0                (pll_calbus_0),
      .pll_calbus_readdata_0       (pll_calbus_readdata_0),
      .pll_calbus_1                (pll_calbus_1),
      .pll_calbus_readdata_1       (pll_calbus_readdata_1),
      .pll_calbus_2                (pll_calbus_2),
      .pll_calbus_readdata_2       (pll_calbus_readdata_2),

      .s0_axi4lite_clk             (s0_axi4lite_clk),   
      .s0_axi4lite_rst_n           (s0_axi4lite_rst_n),
      .s0_axi4lite_awaddr          (s_fbr_axil_to_arch.awaddr),                                  
      .s0_axi4lite_awvalid         (s_fbr_axil_to_arch.awvalid),                                 
      .s0_axi4lite_awready         (s_fbr_axil_to_arch.awready),                                 
      .s0_axi4lite_wdata           (s_fbr_axil_to_arch.wdata),                                   
      .s0_axi4lite_wstrb           (s_fbr_axil_to_arch.wstrb),                                   
      .s0_axi4lite_wvalid          (s_fbr_axil_to_arch.wvalid),                                  
      .s0_axi4lite_wready          (s_fbr_axil_to_arch.wready),                                  
      .s0_axi4lite_bresp           (s_fbr_axil_to_arch.bresp),                                   
      .s0_axi4lite_bvalid          (s_fbr_axil_to_arch.bvalid),                                  
      .s0_axi4lite_bready          (s_fbr_axil_to_arch.bready),                                  
      .s0_axi4lite_araddr          (s_fbr_axil_to_arch.araddr),                                  
      .s0_axi4lite_arvalid         (s_fbr_axil_to_arch.arvalid),                                 
      .s0_axi4lite_arready         (s_fbr_axil_to_arch.arready),                                 
      .s0_axi4lite_rdata           (s_fbr_axil_to_arch.rdata),                                   
      .s0_axi4lite_rresp           (s_fbr_axil_to_arch.rresp),                                   
      .s0_axi4lite_rvalid          (s_fbr_axil_to_arch.rvalid),                                  
      .s0_axi4lite_rready          (s_fbr_axil_to_arch.rready),                                  
      .s0_axi4lite_awprot          (s_fbr_axil_to_arch.awprot),                                  
      .s0_axi4lite_arprot          (s_fbr_axil_to_arch.arprot),                                  
      .m0_axi4lite_awaddr          (m0_axi4lite_awaddr),
      .m0_axi4lite_awvalid         (m0_axi4lite_awvalid),
      .m0_axi4lite_awready         (m0_axi4lite_awready),
      .m0_axi4lite_wdata           (m0_axi4lite_wdata),
      .m0_axi4lite_wstrb           (m0_axi4lite_wstrb),
      .m0_axi4lite_wvalid          (m0_axi4lite_wvalid),
      .m0_axi4lite_wready          (m0_axi4lite_wready),
      .m0_axi4lite_bresp           (m0_axi4lite_bresp),
      .m0_axi4lite_bvalid          (m0_axi4lite_bvalid),
      .m0_axi4lite_bready          (m0_axi4lite_bready),
      .m0_axi4lite_araddr          (m0_axi4lite_araddr),
      .m0_axi4lite_arvalid         (m0_axi4lite_arvalid),
      .m0_axi4lite_arready         (m0_axi4lite_arready),
      .m0_axi4lite_rdata           (m0_axi4lite_rdata),
      .m0_axi4lite_rresp           (m0_axi4lite_rresp),
      .m0_axi4lite_rvalid          (m0_axi4lite_rvalid),
      .m0_axi4lite_rready          (m0_axi4lite_rready),
      .m0_axi4lite_awprot          (m0_axi4lite_awprot),
      .m0_axi4lite_arprot          (m0_axi4lite_arprot),
      .s0_noc_axi4lite_clk         (s_noc_axil_to_arch.clk),
      .s0_noc_axi4lite_rst_n       (s_noc_axil_to_arch.rst_n),
      .s0_noc_axi4lite_awaddr      (s_noc_axil_to_arch.awaddr),
      .s0_noc_axi4lite_awvalid     (s_noc_axil_to_arch.awvalid),
      .s0_noc_axi4lite_awready     (s_noc_axil_to_arch.awready),
      .s0_noc_axi4lite_wdata       (s_noc_axil_to_arch.wdata),
      .s0_noc_axi4lite_wstrb       (s_noc_axil_to_arch.wstrb),
      .s0_noc_axi4lite_wvalid      (s_noc_axil_to_arch.wvalid),
      .s0_noc_axi4lite_wready      (s_noc_axil_to_arch.wready),
      .s0_noc_axi4lite_bresp       (s_noc_axil_to_arch.bresp),
      .s0_noc_axi4lite_bvalid      (s_noc_axil_to_arch.bvalid),
      .s0_noc_axi4lite_bready      (s_noc_axil_to_arch.bready),
      .s0_noc_axi4lite_araddr      (s_noc_axil_to_arch.araddr),
      .s0_noc_axi4lite_arvalid     (s_noc_axil_to_arch.arvalid),
      .s0_noc_axi4lite_arready     (s_noc_axil_to_arch.arready),
      .s0_noc_axi4lite_rdata       (s_noc_axil_to_arch.rdata),
      .s0_noc_axi4lite_rresp       (s_noc_axil_to_arch.rresp),
      .s0_noc_axi4lite_rvalid      (s_noc_axil_to_arch.rvalid),
      .s0_noc_axi4lite_rready      (s_noc_axil_to_arch.rready),
      .s0_noc_axi4lite_awprot      (s_noc_axil_to_arch.awprot),
      .s0_noc_axi4lite_arprot      (s_noc_axil_to_arch.arprot),
      .tniul_rst_n                 (tniul_rst_n),
      .ls_to_cal                   (ls_to_cal),
      .ls_from_cal                 (ls_from_cal),
      .fbr_c2f_rst_n               (fbr_c2f_rst_n)
   );


   generate
      if (ADD_TNIU) begin: gen_tniu
         tniu tniu (
            .clk              (s_noc_axil_to_tniu.clk),      
            .reset            (~s_noc_axil_to_tniu.rst_n), 
            .response_awaddr  (s_noc_axil_to_tniu.awaddr  ),           
            .response_awprot  (s_noc_axil_to_tniu.awprot  ),           
            .response_awvalid (s_noc_axil_to_tniu.awvalid ),          
            .response_awready (s_noc_axil_to_tniu.awready ),          
            .response_wdata   (s_noc_axil_to_tniu.wdata   ),            
            .response_wready  (s_noc_axil_to_tniu.wready  ),           
            .response_wstrb   (s_noc_axil_to_tniu.wstrb   ),            
            .response_wvalid  (s_noc_axil_to_tniu.wvalid  ),           
            .response_bresp   (s_noc_axil_to_tniu.bresp   ),            
            .response_bvalid  (s_noc_axil_to_tniu.bvalid  ),           
            .response_bready  (s_noc_axil_to_tniu.bready  ),           
            .response_araddr  (s_noc_axil_to_tniu.araddr  ),           
            .response_arprot  (s_noc_axil_to_tniu.arprot  ),           
            .response_arvalid (s_noc_axil_to_tniu.arvalid ),          
            .response_arready (s_noc_axil_to_tniu.arready ),          
            .response_rdata   (s_noc_axil_to_tniu.rdata   ),            
            .response_rresp   (s_noc_axil_to_tniu.rresp   ),            
            .response_rvalid  (s_noc_axil_to_tniu.rvalid  ),           
            .response_rready  (s_noc_axil_to_tniu.rready  )           
         );
      end

      if (DEBUG_TOOLS_EN) begin: g_jamb_arbit
         emif_io96b_hps_emif_io96b_hps_200_g4nkt2a_emif_0_ddr4comp_emif_io96b_cal_alt_mem_if_jtag_master_200_6eqlegy emif_io96b_hps_emif_io96b_hps_200_g4nkt2a_emif_0_ddr4comp_emif_io96b_cal_alt_mem_if_jtag_master_200_6eqlegy (
            .clk_clk              (s0_axi4lite_clk),           
            .clk_reset_reset      (~s0_axi4lite_rst_n),        
            .master_reset_reset   (),                          
            .master_address       (jamb_master_address),       
            .master_readdata      (jamb_master_readdata),      
            .master_read          (jamb_master_read),          
            .master_write         (jamb_master_write),         
            .master_writedata     (jamb_master_writedata),     
            .master_waitrequest   (jamb_master_waitrequest),   
            .master_readdatavalid (jamb_master_readdatavalid), 
            .master_byteenable    (jamb_master_byteenable)     
         );


         io0_emif_io96b_hps_emif_io96b_hps_200_g4nkt2a_emif_0_ddr4comp_emif_io96b_cal_200_hpbproa_arbitrator #(
            .AMM_TO_AXIL_INTERCONNECT_ONLY (AMM_TO_AXIL_INTERCONNECT_ONLY)
         ) arbit_and_interconnect (
            .s0_axi4lite_clk              (s0_axi4lite_clk),
            .s0_axi4lite_rst_n            (s0_axi4lite_rst_n),
            .s0_axi4lite_awaddr           (s_fbr_axil_to_jamb_and_arbit.awaddr),
            .s0_axi4lite_awvalid          (s_fbr_axil_to_jamb_and_arbit.awvalid),
            .s0_axi4lite_awready          (s_fbr_axil_to_jamb_and_arbit.awready),
            .s0_axi4lite_araddr           (s_fbr_axil_to_jamb_and_arbit.araddr),
            .s0_axi4lite_arvalid          (s_fbr_axil_to_jamb_and_arbit.arvalid),
            .s0_axi4lite_arready          (s_fbr_axil_to_jamb_and_arbit.arready),
            .s0_axi4lite_wdata            (s_fbr_axil_to_jamb_and_arbit.wdata),
            .s0_axi4lite_wvalid           (s_fbr_axil_to_jamb_and_arbit.wvalid),
            .s0_axi4lite_wready           (s_fbr_axil_to_jamb_and_arbit.wready),
            .s0_axi4lite_rresp            (s_fbr_axil_to_jamb_and_arbit.rresp),
            .s0_axi4lite_rdata            (s_fbr_axil_to_jamb_and_arbit.rdata),
            .s0_axi4lite_rvalid           (s_fbr_axil_to_jamb_and_arbit.rvalid),
            .s0_axi4lite_rready           (s_fbr_axil_to_jamb_and_arbit.rready),
            .s0_axi4lite_bresp            (s_fbr_axil_to_jamb_and_arbit.bresp),
            .s0_axi4lite_bvalid           (s_fbr_axil_to_jamb_and_arbit.bvalid),
            .s0_axi4lite_bready           (s_fbr_axil_to_jamb_and_arbit.bready),

            .jamb_master_address          (jamb_master_address),
            .jamb_master_readdata         (jamb_master_readdata),
            .jamb_master_read             (jamb_master_read),
            .jamb_master_write            (jamb_master_write),
            .jamb_master_writedata        (jamb_master_writedata),
            .jamb_master_waitrequest      (jamb_master_waitrequest),
            .jamb_master_readdatavalid    (jamb_master_readdatavalid),
            .jamb_master_byteenable       (jamb_master_byteenable),
                                                       
            .cal_arch_0_s0_axi4lite_axi4_lite_awaddr  (s_fbr_axil_to_arch.awaddr),
            .cal_arch_0_s0_axi4lite_axi4_lite_awprot  (s_fbr_axil_to_arch.awprot),
            .cal_arch_0_s0_axi4lite_axi4_lite_awvalid (s_fbr_axil_to_arch.awvalid),
            .cal_arch_0_s0_axi4lite_axi4_lite_awready (s_fbr_axil_to_arch.awready),
            .cal_arch_0_s0_axi4lite_axi4_lite_wdata   (s_fbr_axil_to_arch.wdata),
            .cal_arch_0_s0_axi4lite_axi4_lite_wstrb   (s_fbr_axil_to_arch.wstrb),
            .cal_arch_0_s0_axi4lite_axi4_lite_wvalid  (s_fbr_axil_to_arch.wvalid),
            .cal_arch_0_s0_axi4lite_axi4_lite_wready  (s_fbr_axil_to_arch.wready),
            .cal_arch_0_s0_axi4lite_axi4_lite_bresp   (s_fbr_axil_to_arch.bresp),
            .cal_arch_0_s0_axi4lite_axi4_lite_bvalid  (s_fbr_axil_to_arch.bvalid),
            .cal_arch_0_s0_axi4lite_axi4_lite_bready  (s_fbr_axil_to_arch.bready),
            .cal_arch_0_s0_axi4lite_axi4_lite_araddr  (s_fbr_axil_to_arch.araddr),
            .cal_arch_0_s0_axi4lite_axi4_lite_arprot  (s_fbr_axil_to_arch.arprot),
            .cal_arch_0_s0_axi4lite_axi4_lite_arvalid (s_fbr_axil_to_arch.arvalid),
            .cal_arch_0_s0_axi4lite_axi4_lite_arready (s_fbr_axil_to_arch.arready),
            .cal_arch_0_s0_axi4lite_axi4_lite_rdata   (s_fbr_axil_to_arch.rdata),
            .cal_arch_0_s0_axi4lite_axi4_lite_rresp   (s_fbr_axil_to_arch.rresp),
            .cal_arch_0_s0_axi4lite_axi4_lite_rvalid  (s_fbr_axil_to_arch.rvalid),
            .cal_arch_0_s0_axi4lite_axi4_lite_rready  (s_fbr_axil_to_arch.rready)
         );

         if (EXPORT_FBR_INTF) begin: g_export_fbr_axil_from_jamb
            assign s_fbr_axil_to_jamb_and_arbit.awaddr    = s0_axi4lite_awaddr; 
            assign s_fbr_axil_to_jamb_and_arbit.awprot    = s0_axi4lite_awprot; 
            assign s_fbr_axil_to_jamb_and_arbit.awvalid   = s0_axi4lite_awvalid;
            assign s_fbr_axil_to_jamb_and_arbit.wdata     = s0_axi4lite_wdata;  
            assign s_fbr_axil_to_jamb_and_arbit.wstrb     = s0_axi4lite_wstrb;  
            assign s_fbr_axil_to_jamb_and_arbit.wvalid    = s0_axi4lite_wvalid; 
            assign s_fbr_axil_to_jamb_and_arbit.bready    = s0_axi4lite_bready; 
            assign s_fbr_axil_to_jamb_and_arbit.araddr    = s0_axi4lite_araddr; 
            assign s_fbr_axil_to_jamb_and_arbit.arprot    = s0_axi4lite_arprot; 
            assign s_fbr_axil_to_jamb_and_arbit.arvalid   = s0_axi4lite_arvalid;
            assign s_fbr_axil_to_jamb_and_arbit.rready    = s0_axi4lite_rready;          
            
            assign s0_axi4lite_awready          = s_fbr_axil_to_jamb_and_arbit.awready;
            assign s0_axi4lite_wready           = s_fbr_axil_to_jamb_and_arbit.wready; 
            assign s0_axi4lite_bresp            = s_fbr_axil_to_jamb_and_arbit.bresp;  
            assign s0_axi4lite_bvalid           = s_fbr_axil_to_jamb_and_arbit.bvalid; 
            assign s0_axi4lite_arready          = s_fbr_axil_to_jamb_and_arbit.arready;
            assign s0_axi4lite_rdata            = s_fbr_axil_to_jamb_and_arbit.rdata;
            assign s0_axi4lite_rresp            = s_fbr_axil_to_jamb_and_arbit.rresp;
            assign s0_axi4lite_rvalid           = s_fbr_axil_to_jamb_and_arbit.rvalid;

         end else begin: g_tieoff_fbr_axil_from_jamb

            assign s_fbr_axil_to_jamb_and_arbit.awaddr    = '0;
            assign s_fbr_axil_to_jamb_and_arbit.awprot    = '0;
            assign s_fbr_axil_to_jamb_and_arbit.awvalid   = '0;
            assign s_fbr_axil_to_jamb_and_arbit.wdata     = '0;
            assign s_fbr_axil_to_jamb_and_arbit.wstrb     = '0;
            assign s_fbr_axil_to_jamb_and_arbit.wvalid    = '0;
            assign s_fbr_axil_to_jamb_and_arbit.bready    = '0;
            assign s_fbr_axil_to_jamb_and_arbit.araddr    = '0;
            assign s_fbr_axil_to_jamb_and_arbit.arprot    = '0;
            assign s_fbr_axil_to_jamb_and_arbit.arvalid   = '0;
            assign s_fbr_axil_to_jamb_and_arbit.rready    = '0;
            
            assign s0_axi4lite_awready          = '0; 
            assign s0_axi4lite_wready           = '0; 
            assign s0_axi4lite_bresp            = '0; 
            assign s0_axi4lite_bvalid           = '0; 
            assign s0_axi4lite_arready          = '0; 
            assign s0_axi4lite_rdata            = '0; 
            assign s0_axi4lite_rresp            = '0; 
            assign s0_axi4lite_rvalid           = '0; 

            
         end

      end else begin: g_skip_jamb
         if (EXPORT_FBR_INTF) begin: g_export_fbr_axil
            assign s_fbr_axil_to_arch.awaddr    = s0_axi4lite_awaddr; 
            assign s_fbr_axil_to_arch.awprot    = s0_axi4lite_awprot; 
            assign s_fbr_axil_to_arch.awvalid   = s0_axi4lite_awvalid;
            assign s_fbr_axil_to_arch.wdata     = s0_axi4lite_wdata;  
            assign s_fbr_axil_to_arch.wstrb     = s0_axi4lite_wstrb;  
            assign s_fbr_axil_to_arch.wvalid    = s0_axi4lite_wvalid; 
            assign s_fbr_axil_to_arch.bready    = s0_axi4lite_bready; 
            assign s_fbr_axil_to_arch.araddr    = s0_axi4lite_araddr; 
            assign s_fbr_axil_to_arch.arprot    = s0_axi4lite_arprot; 
            assign s_fbr_axil_to_arch.arvalid   = s0_axi4lite_arvalid;
            assign s_fbr_axil_to_arch.rready    = s0_axi4lite_rready;          
            
            assign s0_axi4lite_awready          = s_fbr_axil_to_arch.awready;
            assign s0_axi4lite_wready           = s_fbr_axil_to_arch.wready; 
            assign s0_axi4lite_bresp            = s_fbr_axil_to_arch.bresp;  
            assign s0_axi4lite_bvalid           = s_fbr_axil_to_arch.bvalid; 
            assign s0_axi4lite_arready          = s_fbr_axil_to_arch.arready;
            assign s0_axi4lite_rdata            = s_fbr_axil_to_arch.rdata;
            assign s0_axi4lite_rresp            = s_fbr_axil_to_arch.rresp;
            assign s0_axi4lite_rvalid           = s_fbr_axil_to_arch.rvalid;

         end else begin: g_tieoff_fbr_axil
            assign s_fbr_axil_to_arch.awaddr    = '0;
            assign s_fbr_axil_to_arch.awprot    = '0;
            assign s_fbr_axil_to_arch.awvalid   = '0;
            assign s_fbr_axil_to_arch.wdata     = '0;
            assign s_fbr_axil_to_arch.wstrb     = '0;
            assign s_fbr_axil_to_arch.wvalid    = '0;
            assign s_fbr_axil_to_arch.bready    = '0;
            assign s_fbr_axil_to_arch.araddr    = '0;
            assign s_fbr_axil_to_arch.arprot    = '0;
            assign s_fbr_axil_to_arch.arvalid   = '0;
            assign s_fbr_axil_to_arch.rready    = '0;
            
            assign s0_axi4lite_awready          = '0; 
            assign s0_axi4lite_wready           = '0; 
            assign s0_axi4lite_bresp            = '0; 
            assign s0_axi4lite_bvalid           = '0; 
            assign s0_axi4lite_arready          = '0; 
            assign s0_axi4lite_rdata            = '0; 
            assign s0_axi4lite_rresp            = '0; 
            assign s0_axi4lite_rvalid           = '0; 
         end
      end
   endgenerate








endmodule




